<?php

namespace Lc\ShopBundle\Form\Backend\Order;


use Doctrine\ORM\EntityManagerInterface;
use Lc\ShopBundle\Context\OrderPaymentInterface;
use Lc\ShopBundle\Model\OrderPayment;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\ButtonType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\DateType;
use Symfony\Component\Form\Extension\Core\Type\NumberType;
use Symfony\Component\Form\Extension\Core\Type\TextareaType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class OrderPaymentType extends AbstractType
{
        protected $em;

        public function __construct(EntityManagerInterface $em)
        {
                $this->em = $em;
        }

        public function buildForm(FormBuilderInterface $builder, array $options)
        {
                $builder
                        ->add('type', ChoiceType::class, array(
                                'choices' => array(
                                        'field.orderPayment.' . OrderPayment::TYPE_CHEQUE => OrderPayment::TYPE_CHEQUE,
                                        'field.orderPayment.' . OrderPayment::TYPE_CREDIT => OrderPayment::TYPE_CREDIT,
                                        'field.orderPayment.' . OrderPayment::TYPE_CREDIT_CARD => OrderPayment::TYPE_CREDIT_CARD
                                ),
                                'required' => true
                        ))
                        ->add('paidAt', DateType::class, array(
                                'widget' => 'single_text',
                                'required' => true
                        ))
                        ->add('reference', TextType::class)
                        ->add('amount', NumberType::class)
                        ->add('comment', TextareaType::class)
                        ->add('saveOrderPayment', ButtonType::class, array(
                                'label' => 'field.OrderShop.saveOrderPayment'
                        ));


        }

        public function configureOptions(OptionsResolver $resolver)
        {
                $resolver->setDefaults([
                        'data_class' => $this->em->getClassMetadata(OrderPaymentInterface::class)->getName(),
                ]);
        }
}
